---
title: Object.getPrototypeOf()
slug: Web/JavaScript/Reference/Global_Objects/Object/getPrototypeOf
tags:
  - ECMAScript 5
  - JavaScript
  - Method
  - Object
---
<div>{{JSRef}}</div>

<p>The <strong><code>Object.getPrototypeOf()</code></strong> method returns the prototype (i.e. the value of the internal <code>[[Prototype]]</code> property) of the specified object.</p>

<div>{{EmbedInteractiveExample("pages/js/object-getprototypeof.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Object.getPrototypeOf(<var>obj</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>obj</var></code></dt>
 <dd>The object whose prototype is to be returned.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The prototype of the given object. If there are no inherited properties, {{jsxref("null")}} is returned.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_getPrototypeOf">Using getPrototypeOf</h3>

<pre class="brush: js notranslate">var proto = {};
var obj = Object.create(proto);
Object.getPrototypeOf(obj) === proto; // true
</pre>

<h3 id="Non-object_coercion">Non-object coercion</h3>

<p>In ES5, it will throw a {{jsxref("TypeError")}} exception if the <var>obj</var> parameter isn't an object. In ES2015, the parameter will be coerced to an {{jsxref("Object")}}.</p>

<pre class="brush: js notranslate">Object.getPrototypeOf('foo');
// TypeError: "foo" is not an object (ES5 code)
Object.getPrototypeOf('foo');
// String.prototype                  (ES2015 code)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.getprototypeof', 'Object.getPrototypeOf')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Object.getPrototypeOf")}}</p>

<h3 id="Opera-specific_notes">Opera-specific notes</h3>

<p>Even though older Opera versions don't support <code>Object.getPrototypeOf()</code> yet, Opera supports the non-standard {{jsxref("Object.proto", "__proto__")}} property since Opera 10.50.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.prototype.isPrototypeOf()")}}</li>
 <li>{{jsxref("Object.setPrototypeOf()")}}</li>
 <li>{{jsxref("Object.prototype.__proto__")}}</li>
 <li>John Resig's post on <a class="external" href="http://ejohn.org/blog/objectgetprototypeof/">getPrototypeOf</a></li>
 <li>{{jsxref("Reflect.getPrototypeOf()")}}</li>
</ul>
